# booking_hint

BookingHint - JavaScript client for booking_hint
This is the API specification for the bookingHint project.  Built on my propertyobject.js project, I have aimed to create a generic framework that can be easily adapted to as many applications as possible. 
This SDK is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 0.0.1
- Package version: 0.0.1
- Build package: class io.swagger.codegen.languages.JavascriptClientCodegen

## Installation

### For [Node.js](https://nodejs.org/)

#### npm

To publish the library as a [npm](https://www.npmjs.com/),
please follow the procedure in ["Publishing npm packages"](https://docs.npmjs.com/getting-started/publishing-npm-packages).

Then install it via:

```shell
npm install booking_hint --save
```

#### git
#
If the library is hosted at a git repository, e.g.
https://github.com/YOUR_USERNAME/booking_hint
then install it via:

```shell
    npm install YOUR_USERNAME/booking_hint --save
```

### For browser

The library also works in the browser environment via npm and [browserify](http://browserify.org/). After following
the above steps with Node.js and installing browserify with `npm install -g browserify`,
perform the following (assuming *main.js* is your entry file):

```shell
browserify main.js > bundle.js
```

Then include *bundle.js* in the HTML pages.

## Getting Started

Please follow the [installation](#installation) instruction and execute the following JS code:

```javascript
var BookingHint = require('booking_hint');

var api = new BookingHint.AuthApi()

var username = "username_example"; // {String} The username that we want to login with. 

var body = new BookingHint.Body(); // {Body} Set the property \"password\" to the password to login with. 


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
api.loginPOST(username, body, callback);

```

## Documentation for API Endpoints

All URIs are relative to *http://localhost:8081*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*BookingHint.AuthApi* | [**loginPOST**](docs/AuthApi.md#loginPOST) | **POST** /login | 
*BookingHint.AuthApi* | [**logoutDELETE**](docs/AuthApi.md#logoutDELETE) | **DELETE** /logout | 
*BookingHint.MessageApi* | [**messagesGET**](docs/MessageApi.md#messagesGET) | **GET** /messages | 
*BookingHint.MessageApi* | [**messagesGenericMessageidGET**](docs/MessageApi.md#messagesGenericMessageidGET) | **GET** /messages/generic/{messageid} | 
*BookingHint.MessageApi* | [**messagesGenericMessageidPropertykeyPUT**](docs/MessageApi.md#messagesGenericMessageidPropertykeyPUT) | **PUT** /messages/generic/{messageid}/{propertykey} | 
*BookingHint.MessageApi* | [**messagesSmsPOST**](docs/MessageApi.md#messagesSmsPOST) | **POST** /messages/sms | 
*BookingHint.UserApi* | [**usersGET**](docs/UserApi.md#usersGET) | **GET** /users | 
*BookingHint.UserApi* | [**usersUsernameAdminGET**](docs/UserApi.md#usersUsernameAdminGET) | **GET** /users/{username}/admin | 
*BookingHint.UserApi* | [**usersUsernameAdminPUT**](docs/UserApi.md#usersUsernameAdminPUT) | **PUT** /users/{username}/admin | 
*BookingHint.UserApi* | [**usersUsernameDELETE**](docs/UserApi.md#usersUsernameDELETE) | **DELETE** /users/{username} | 
*BookingHint.UserApi* | [**usersUsernamePOST**](docs/UserApi.md#usersUsernamePOST) | **POST** /users/{username} | 
*BookingHint.UserApi* | [**usersUsernamePasswordPUT**](docs/UserApi.md#usersUsernamePasswordPUT) | **PUT** /users/{username}/password | 
*BookingHint.UserApi* | [**usersUsernameSettingsDELETE**](docs/UserApi.md#usersUsernameSettingsDELETE) | **DELETE** /users/{username}/settings | 
*BookingHint.UserApi* | [**usersUsernameSettingsGET**](docs/UserApi.md#usersUsernameSettingsGET) | **GET** /users/{username}/settings | 
*BookingHint.UserApi* | [**usersUsernameSettingsSettingkeyGET**](docs/UserApi.md#usersUsernameSettingsSettingkeyGET) | **GET** /users/{username}/settings/{settingkey} | 
*BookingHint.UserApi* | [**usersUsernameSettingsSettingkeyPUT**](docs/UserApi.md#usersUsernameSettingsSettingkeyPUT) | **PUT** /users/{username}/settings/{settingkey} | 


## Documentation for Models

 - [BookingHint.AuthKey](docs/AuthKey.md)
 - [BookingHint.Body](docs/Body.md)
 - [BookingHint.Body1](docs/Body1.md)
 - [BookingHint.Body2](docs/Body2.md)
 - [BookingHint.Body3](docs/Body3.md)
 - [BookingHint.Body4](docs/Body4.md)
 - [BookingHint.Message](docs/Message.md)
 - [BookingHint.Messages](docs/Messages.md)
 - [BookingHint.PropertyLogItem](docs/PropertyLogItem.md)
 - [BookingHint.PropertyObject](docs/PropertyObject.md)
 - [BookingHint.PropertyObjects](docs/PropertyObjects.md)
 - [BookingHint.UserIsAdmin](docs/UserIsAdmin.md)
 - [BookingHint.Usernames](docs/Usernames.md)


## Documentation for Authorization


### authKey

- **Type**: API key
- **API key parameter name**: authKey
- **Location**: URL query string

