/**
 * bookingHint
 * This is the API specification for the bookingHint project.  Built on my propertyobject.js project, I have aimed to create a generic framework that can be easily adapted to as many applications as possible. 
 *
 * OpenAPI spec version: 0.0.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/AuthKey', 'model/Body'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/AuthKey'), require('../model/Body'));
  } else {
    // Browser globals (root is window)
    if (!root.BookingHint) {
      root.BookingHint = {};
    }
    root.BookingHint.AuthApi = factory(root.BookingHint.ApiClient, root.BookingHint.AuthKey, root.BookingHint.Body);
  }
}(this, function(ApiClient, AuthKey, Body) {
  'use strict';

  /**
   * Auth service.
   * @module api/AuthApi
   * @version 0.0.1
   */

  /**
   * Constructs a new AuthApi. 
   * @alias module:api/AuthApi
   * @class
   * @param {module:ApiClient} apiClient Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the loginPOST operation.
     * @callback module:api/AuthApi~loginPOSTCallback
     * @param {String} error Error message, if any.
     * @param {module:model/AuthKey} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Creates a new session, and returns a API key that can be used to access the API.  Sessions expired after a fixed length of time. 
     * @param {String} username The username that we want to login with. 
     * @param {module:model/Body} body Set the property \&quot;password\&quot; to the password to login with. 
     * @param {module:api/AuthApi~loginPOSTCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/AuthKey}
     */
    this.loginPOST = function(username, body, callback) {
      var postBody = body;

      // verify the required parameter 'username' is set
      if (username == undefined || username == null) {
        throw new Error("Missing the required parameter 'username' when calling loginPOST");
      }

      // verify the required parameter 'body' is set
      if (body == undefined || body == null) {
        throw new Error("Missing the required parameter 'body' when calling loginPOST");
      }


      var pathParams = {
      };
      var queryParams = {
        'username': username
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = AuthKey;

      return this.apiClient.callApi(
        '/login', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the logoutDELETE operation.
     * @callback module:api/AuthApi~logoutDELETECallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Deletes the session that is associated with authKey.  Returns a 404 if the authKey doesnt exist. 
     * @param {module:api/AuthApi~logoutDELETECallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.logoutDELETE = function(callback) {
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['authKey'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/logout', 'DELETE',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
