/**
 * bookingHint
 * This is the API specification for the bookingHint project.  Built on my propertyobject.js project, I have aimed to create a generic framework that can be easily adapted to as many applications as possible. 
 *
 * OpenAPI spec version: 0.0.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/Messages', 'model/Message', 'model/Body1'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/Messages'), require('../model/Message'), require('../model/Body1'));
  } else {
    // Browser globals (root is window)
    if (!root.BookingHint) {
      root.BookingHint = {};
    }
    root.BookingHint.MessageApi = factory(root.BookingHint.ApiClient, root.BookingHint.Messages, root.BookingHint.Message, root.BookingHint.Body1);
  }
}(this, function(ApiClient, Messages, Message, Body1) {
  'use strict';

  /**
   * Message service.
   * @module api/MessageApi
   * @version 0.0.1
   */

  /**
   * Constructs a new MessageApi. 
   * @alias module:api/MessageApi
   * @class
   * @param {module:ApiClient} apiClient Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the messagesGET operation.
     * @callback module:api/MessageApi~messagesGETCallback
     * @param {String} error Error message, if any.
     * @param {module:model/Messages} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get all messages.  Messages are ordered in ascending chronological order. 
     * @param {Object} opts Optional parameters
     * @param {Number} opts.to A timestamp representing the earliest instant to return. 
     * @param {Number} opts.from A timestamp representing the latest instant to return. 
     * @param {module:api/MessageApi~messagesGETCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/Messages}
     */
    this.messagesGET = function(opts, callback) {
      opts = opts || {};
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
        'to': opts['to'],
        'from': opts['from']
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['authKey'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = Messages;

      return this.apiClient.callApi(
        '/messages', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the messagesGenericMessageidGET operation.
     * @callback module:api/MessageApi~messagesGenericMessageidGETCallback
     * @param {String} error Error message, if any.
     * @param {module:model/Message} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Gets a object representing an individual message. 
     * @param {String} messageid The id of the message we wish to get. 
     * @param {module:api/MessageApi~messagesGenericMessageidGETCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/Message}
     */
    this.messagesGenericMessageidGET = function(messageid, callback) {
      var postBody = null;

      // verify the required parameter 'messageid' is set
      if (messageid == undefined || messageid == null) {
        throw new Error("Missing the required parameter 'messageid' when calling messagesGenericMessageidGET");
      }


      var pathParams = {
        'messageid': messageid
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['authKey'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = Message;

      return this.apiClient.callApi(
        '/messages/generic/{messageid}', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the messagesGenericMessageidPropertykeyPUT operation.
     * @callback module:api/MessageApi~messagesGenericMessageidPropertykeyPUTCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Set the property of a message to a new value.  If the message property is not editable, then it will fail with 400.  If the new value does not pass validation, then it will also fail with 400. 
     * @param {String} messageid The id of the message we are working with. 
     * @param {String} propertykey The key we wish to edit. 
     * @param {Object} body Set the property \&quot;value\&quot; to the new value for this. 
     * @param {module:api/MessageApi~messagesGenericMessageidPropertykeyPUTCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.messagesGenericMessageidPropertykeyPUT = function(messageid, propertykey, body, callback) {
      var postBody = body;

      // verify the required parameter 'messageid' is set
      if (messageid == undefined || messageid == null) {
        throw new Error("Missing the required parameter 'messageid' when calling messagesGenericMessageidPropertykeyPUT");
      }

      // verify the required parameter 'propertykey' is set
      if (propertykey == undefined || propertykey == null) {
        throw new Error("Missing the required parameter 'propertykey' when calling messagesGenericMessageidPropertykeyPUT");
      }

      // verify the required parameter 'body' is set
      if (body == undefined || body == null) {
        throw new Error("Missing the required parameter 'body' when calling messagesGenericMessageidPropertykeyPUT");
      }


      var pathParams = {
        'messageid': messageid,
        'propertykey': propertykey
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['authKey'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/messages/generic/{messageid}/{propertykey}', 'PUT',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the messagesSmsPOST operation.
     * @callback module:api/MessageApi~messagesSmsPOSTCallback
     * @param {String} error Error message, if any.
     * @param {module:model/Message} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create a new message definition of type SMS.  All fields are required.  The meta field should contain any supporting information, that, for example, will be displayed to the user to confirm information about the message, in order to make better decisions about queueing and message content.  Properties in the meta field will automatically have \&quot;meta_\&quot; prepended to their key, to avoid collisions. 
     * @param {module:model/Body1} body The information required to initialize a SMS message. 
     * @param {module:api/MessageApi~messagesSmsPOSTCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/Message}
     */
    this.messagesSmsPOST = function(body, callback) {
      var postBody = body;

      // verify the required parameter 'body' is set
      if (body == undefined || body == null) {
        throw new Error("Missing the required parameter 'body' when calling messagesSmsPOST");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['authKey'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = Message;

      return this.apiClient.callApi(
        '/messages/sms', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
