/**
 * bookingHint
 * This is the API specification for the bookingHint project.  Built on my propertyobject.js project, I have aimed to create a generic framework that can be easily adapted to as many applications as possible. 
 *
 * OpenAPI spec version: 0.0.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/Usernames', 'model/UserIsAdmin', 'model/Body3', 'model/Body2', 'model/Body4', 'model/PropertyObjects', 'model/PropertyObject'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/Usernames'), require('../model/UserIsAdmin'), require('../model/Body3'), require('../model/Body2'), require('../model/Body4'), require('../model/PropertyObjects'), require('../model/PropertyObject'));
  } else {
    // Browser globals (root is window)
    if (!root.BookingHint) {
      root.BookingHint = {};
    }
    root.BookingHint.UserApi = factory(root.BookingHint.ApiClient, root.BookingHint.Usernames, root.BookingHint.UserIsAdmin, root.BookingHint.Body3, root.BookingHint.Body2, root.BookingHint.Body4, root.BookingHint.PropertyObjects, root.BookingHint.PropertyObject);
  }
}(this, function(ApiClient, Usernames, UserIsAdmin, Body3, Body2, Body4, PropertyObjects, PropertyObject) {
  'use strict';

  /**
   * User service.
   * @module api/UserApi
   * @version 0.0.1
   */

  /**
   * Constructs a new UserApi. 
   * @alias module:api/UserApi
   * @class
   * @param {module:ApiClient} apiClient Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the usersGET operation.
     * @callback module:api/UserApi~usersGETCallback
     * @param {String} error Error message, if any.
     * @param {module:model/Usernames} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get the usernames of all existing users. Must be admin. 
     * @param {module:api/UserApi~usersGETCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/Usernames}
     */
    this.usersGET = function(callback) {
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['authKey'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = Usernames;

      return this.apiClient.callApi(
        '/users', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the usersUsernameAdminGET operation.
     * @callback module:api/UserApi~usersUsernameAdminGETCallback
     * @param {String} error Error message, if any.
     * @param {module:model/UserIsAdmin} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Gets whether the user is admin or not.  Must be logged in to the account, or a admin. 
     * @param {String} username The username of the user. 
     * @param {module:api/UserApi~usersUsernameAdminGETCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/UserIsAdmin}
     */
    this.usersUsernameAdminGET = function(username, callback) {
      var postBody = null;

      // verify the required parameter 'username' is set
      if (username == undefined || username == null) {
        throw new Error("Missing the required parameter 'username' when calling usersUsernameAdminGET");
      }


      var pathParams = {
        'username': username
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['authKey'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = UserIsAdmin;

      return this.apiClient.callApi(
        '/users/{username}/admin', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the usersUsernameAdminPUT operation.
     * @callback module:api/UserApi~usersUsernameAdminPUTCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Set the user as admin or not.  Requires admin account. You cannot remove administrator from yourself. 
     * @param {String} username The username of the user. 
     * @param {module:model/Body3} body Set the property admin to true or false. 
     * @param {module:api/UserApi~usersUsernameAdminPUTCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.usersUsernameAdminPUT = function(username, body, callback) {
      var postBody = body;

      // verify the required parameter 'username' is set
      if (username == undefined || username == null) {
        throw new Error("Missing the required parameter 'username' when calling usersUsernameAdminPUT");
      }

      // verify the required parameter 'body' is set
      if (body == undefined || body == null) {
        throw new Error("Missing the required parameter 'body' when calling usersUsernameAdminPUT");
      }


      var pathParams = {
        'username': username
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['authKey'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/users/{username}/admin', 'PUT',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the usersUsernameDELETE operation.
     * @callback module:api/UserApi~usersUsernameDELETECallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Deletes a user.  Requires admin account.  Will return a 404 if you attempt to delete your own account, or a if otherwise unable to delete the account specified. 
     * @param {String} username The username that we are trying to delete. 
     * @param {module:api/UserApi~usersUsernameDELETECallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.usersUsernameDELETE = function(username, callback) {
      var postBody = null;

      // verify the required parameter 'username' is set
      if (username == undefined || username == null) {
        throw new Error("Missing the required parameter 'username' when calling usersUsernameDELETE");
      }


      var pathParams = {
        'username': username
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['authKey'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/users/{username}', 'DELETE',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the usersUsernamePOST operation.
     * @callback module:api/UserApi~usersUsernamePOSTCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Creates a new user.  Must be admin.  Usernames must only contain letters and numbers, and are not case sensitive. A error 400 indicates a bad or existing username. 
     * @param {String} username The username that we are trying to create. 
     * @param {module:model/Body2} body Set the property \&quot;password\&quot; to the new password. 
     * @param {module:api/UserApi~usersUsernamePOSTCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.usersUsernamePOST = function(username, body, callback) {
      var postBody = body;

      // verify the required parameter 'username' is set
      if (username == undefined || username == null) {
        throw new Error("Missing the required parameter 'username' when calling usersUsernamePOST");
      }

      // verify the required parameter 'body' is set
      if (body == undefined || body == null) {
        throw new Error("Missing the required parameter 'body' when calling usersUsernamePOST");
      }


      var pathParams = {
        'username': username
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['authKey'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/users/{username}', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the usersUsernamePasswordPUT operation.
     * @callback module:api/UserApi~usersUsernamePasswordPUTCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Set the user&#39;s password.  Requires being logged in, or admin. 
     * @param {String} username The username of the user. 
     * @param {module:model/Body4} body Set the property \&quot;password\&quot; to the new password to use. 
     * @param {module:api/UserApi~usersUsernamePasswordPUTCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.usersUsernamePasswordPUT = function(username, body, callback) {
      var postBody = body;

      // verify the required parameter 'username' is set
      if (username == undefined || username == null) {
        throw new Error("Missing the required parameter 'username' when calling usersUsernamePasswordPUT");
      }

      // verify the required parameter 'body' is set
      if (body == undefined || body == null) {
        throw new Error("Missing the required parameter 'body' when calling usersUsernamePasswordPUT");
      }


      var pathParams = {
        'username': username
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['authKey'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/users/{username}/password', 'PUT',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the usersUsernameSettingsDELETE operation.
     * @callback module:api/UserApi~usersUsernameSettingsDELETECallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Deletes all settings for this user, resetting them to default.  Requires being logged in, or admin. 
     * @param {String} username The username of the user. 
     * @param {module:api/UserApi~usersUsernameSettingsDELETECallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.usersUsernameSettingsDELETE = function(username, callback) {
      var postBody = null;

      // verify the required parameter 'username' is set
      if (username == undefined || username == null) {
        throw new Error("Missing the required parameter 'username' when calling usersUsernameSettingsDELETE");
      }


      var pathParams = {
        'username': username
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['authKey'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/users/{username}/settings', 'DELETE',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the usersUsernameSettingsGET operation.
     * @callback module:api/UserApi~usersUsernameSettingsGETCallback
     * @param {String} error Error message, if any.
     * @param {module:model/PropertyObjects} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Gets all individual user settings and their values.  Requires being logged in, or admin. 
     * @param {String} username The username of the user. 
     * @param {module:api/UserApi~usersUsernameSettingsGETCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/PropertyObjects}
     */
    this.usersUsernameSettingsGET = function(username, callback) {
      var postBody = null;

      // verify the required parameter 'username' is set
      if (username == undefined || username == null) {
        throw new Error("Missing the required parameter 'username' when calling usersUsernameSettingsGET");
      }


      var pathParams = {
        'username': username
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['authKey'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = PropertyObjects;

      return this.apiClient.callApi(
        '/users/{username}/settings', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the usersUsernameSettingsSettingkeyGET operation.
     * @callback module:api/UserApi~usersUsernameSettingsSettingkeyGETCallback
     * @param {String} error Error message, if any.
     * @param {module:model/PropertyObject} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get a individual user setting.  Requires being logged in, or admin. 
     * @param {String} username The username of the user. 
     * @param {String} settingkey The key denoting the setting we wish to work with. 
     * @param {module:api/UserApi~usersUsernameSettingsSettingkeyGETCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/PropertyObject}
     */
    this.usersUsernameSettingsSettingkeyGET = function(username, settingkey, callback) {
      var postBody = null;

      // verify the required parameter 'username' is set
      if (username == undefined || username == null) {
        throw new Error("Missing the required parameter 'username' when calling usersUsernameSettingsSettingkeyGET");
      }

      // verify the required parameter 'settingkey' is set
      if (settingkey == undefined || settingkey == null) {
        throw new Error("Missing the required parameter 'settingkey' when calling usersUsernameSettingsSettingkeyGET");
      }


      var pathParams = {
        'username': username,
        'settingkey': settingkey
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['authKey'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = PropertyObject;

      return this.apiClient.callApi(
        '/users/{username}/settings/{settingkey}', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the usersUsernameSettingsSettingkeyPUT operation.
     * @callback module:api/UserApi~usersUsernameSettingsSettingkeyPUTCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Set a individual user setting. May fail due to validation, or if the property is not editable (400).  Will also fail if the setting doesn&#39;t exist (404).  Requires being logged in, or admin. 
     * @param {String} username The username of the user. 
     * @param {String} settingkey The key denoting the setting we wish to work with. 
     * @param {Object} body Set the property \&quot;value\&quot; to the new value for this. 
     * @param {module:api/UserApi~usersUsernameSettingsSettingkeyPUTCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.usersUsernameSettingsSettingkeyPUT = function(username, settingkey, body, callback) {
      var postBody = body;

      // verify the required parameter 'username' is set
      if (username == undefined || username == null) {
        throw new Error("Missing the required parameter 'username' when calling usersUsernameSettingsSettingkeyPUT");
      }

      // verify the required parameter 'settingkey' is set
      if (settingkey == undefined || settingkey == null) {
        throw new Error("Missing the required parameter 'settingkey' when calling usersUsernameSettingsSettingkeyPUT");
      }

      // verify the required parameter 'body' is set
      if (body == undefined || body == null) {
        throw new Error("Missing the required parameter 'body' when calling usersUsernameSettingsSettingkeyPUT");
      }


      var pathParams = {
        'username': username,
        'settingkey': settingkey
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['authKey'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/users/{username}/settings/{settingkey}', 'PUT',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
