/**
 * bookingHint
 * This is the API specification for the bookingHint project.  Built on my propertyobject.js project, I have aimed to create a generic framework that can be easily adapted to as many applications as possible. 
 *
 * OpenAPI spec version: 0.0.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/PropertyObjects'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./PropertyObjects'));
  } else {
    // Browser globals (root is window)
    if (!root.BookingHint) {
      root.BookingHint = {};
    }
    root.BookingHint.Body1 = factory(root.BookingHint.ApiClient, root.BookingHint.PropertyObjects);
  }
}(this, function(ApiClient, PropertyObjects) {
  'use strict';




  /**
   * The Body1 model module.
   * @module model/Body1
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>Body1</code>.
   * @alias module:model/Body1
   * @class
   */
  var exports = function() {
    var _this = this;








  };

  /**
   * Constructs a <code>Body1</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Body1} obj Optional instance to populate.
   * @return {module:model/Body1} The populated <code>Body1</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('category')) {
        obj['category'] = ApiClient.convertToType(data['category'], 'String');
      }
      if (data.hasOwnProperty('title')) {
        obj['title'] = ApiClient.convertToType(data['title'], 'String');
      }
      if (data.hasOwnProperty('scheduled')) {
        obj['scheduled'] = ApiClient.convertToType(data['scheduled'], 'Number');
      }
      if (data.hasOwnProperty('valid')) {
        obj['valid'] = ApiClient.convertToType(data['valid'], 'Number');
      }
      if (data.hasOwnProperty('mobile')) {
        obj['mobile'] = ApiClient.convertToType(data['mobile'], 'String');
      }
      if (data.hasOwnProperty('body')) {
        obj['body'] = ApiClient.convertToType(data['body'], 'String');
      }
      if (data.hasOwnProperty('meta')) {
        obj['meta'] = PropertyObjects.constructFromObject(data['meta']);
      }
    }
    return obj;
  }

  /**
   * A string key that can be used to sort etc. 
   * @member {String} category
   */
  exports.prototype['category'] = undefined;
  /**
   * The title is used to describe the message to the user. 
   * @member {String} title
   */
  exports.prototype['title'] = undefined;
  /**
   * The timestamp (ms) when this is scheduled to be sent. 
   * @member {Number} scheduled
   */
  exports.prototype['scheduled'] = undefined;
  /**
   * The time in ms that this message is valid to be queued for. 
   * @member {Number} valid
   */
  exports.prototype['valid'] = undefined;
  /**
   * A valid mobile number. This is defined in the settings. 
   * @member {String} mobile
   */
  exports.prototype['mobile'] = undefined;
  /**
   * The actual SMS content that you wish to send. 
   * @member {String} body
   */
  exports.prototype['body'] = undefined;
  /**
   * @member {module:model/PropertyObjects} meta
   */
  exports.prototype['meta'] = undefined;



  return exports;
}));


