/**
 * bookingHint
 * This is the API specification for the bookingHint project.  Built on my propertyobject.js project, I have aimed to create a generic framework that can be easily adapted to as many applications as possible. 
 *
 * OpenAPI spec version: 0.0.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.BookingHint) {
      root.BookingHint = {};
    }
    root.BookingHint.PropertyLogItem = factory(root.BookingHint.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The PropertyLogItem model module.
   * @module model/PropertyLogItem
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>PropertyLogItem</code>.
   * A row representing a action that was performed on a PropertyObject. 
   * @alias module:model/PropertyLogItem
   * @class
   */
  var exports = function() {
    var _this = this;



  };

  /**
   * Constructs a <code>PropertyLogItem</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/PropertyLogItem} obj Optional instance to populate.
   * @return {module:model/PropertyLogItem} The populated <code>PropertyLogItem</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('timestamp')) {
        obj['timestamp'] = ApiClient.convertToType(data['timestamp'], 'Number');
      }
      if (data.hasOwnProperty('message')) {
        obj['message'] = ApiClient.convertToType(data['message'], 'String');
      }
    }
    return obj;
  }

  /**
   * The timestamp (ms) indicating when this item was logged. 
   * @member {Number} timestamp
   */
  exports.prototype['timestamp'] = undefined;
  /**
   * The message that was provided to be logged. 
   * @member {String} message
   */
  exports.prototype['message'] = undefined;



  return exports;
}));


