/**
 * bookingHint
 * This is the API specification for the bookingHint project.  Built on my propertyobject.js project, I have aimed to create a generic framework that can be easily adapted to as many applications as possible. 
 *
 * OpenAPI spec version: 0.0.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/PropertyLogItem'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./PropertyLogItem'));
  } else {
    // Browser globals (root is window)
    if (!root.BookingHint) {
      root.BookingHint = {};
    }
    root.BookingHint.PropertyObject = factory(root.BookingHint.ApiClient, root.BookingHint.PropertyLogItem);
  }
}(this, function(ApiClient, PropertyLogItem) {
  'use strict';




  /**
   * The PropertyObject model module.
   * @module model/PropertyObject
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>PropertyObject</code>.
   * These objects represent specific fields within a object or similar, providing reusable utilities, such as how to display, and what kind of value is used. 
   * @alias module:model/PropertyObject
   * @class
   */
  var exports = function() {
    var _this = this;






  };

  /**
   * Constructs a <code>PropertyObject</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/PropertyObject} obj Optional instance to populate.
   * @return {module:model/PropertyObject} The populated <code>PropertyObject</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('key')) {
        obj['key'] = ApiClient.convertToType(data['key'], 'String');
      }
      if (data.hasOwnProperty('validator')) {
        obj['validator'] = ApiClient.convertToType(data['validator'], 'String');
      }
      if (data.hasOwnProperty('editable')) {
        obj['editable'] = ApiClient.convertToType(data['editable'], 'Boolean');
      }
      if (data.hasOwnProperty('display')) {
        obj['display'] = ApiClient.convertToType(data['display'], 'String');
      }
      if (data.hasOwnProperty('logs')) {
        obj['logs'] = ApiClient.convertToType(data['logs'], [PropertyLogItem]);
      }
    }
    return obj;
  }

  /**
   * The key this property is stored under. This can be used in conjunection with database code, to serialize to and from databases. 
   * @member {String} key
   */
  exports.prototype['key'] = undefined;
  /**
   * The kind of validator used by this property. Refer to the docs. 
   * @member {String} validator
   */
  exports.prototype['validator'] = undefined;
  /**
   * Whether this property will accept changes or not. 
   * @member {Boolean} editable
   */
  exports.prototype['editable'] = undefined;
  /**
   * The kind of display that this field is best suited to. Refer to the docs. 
   * @member {String} display
   */
  exports.prototype['display'] = undefined;
  /**
   * An array of log items. This property is not writeable. 
   * @member {Array.<module:model/PropertyLogItem>} logs
   */
  exports.prototype['logs'] = undefined;



  return exports;
}));


